clear all
close all


load data_year
%%
%Analyse data of each subsystem
N=682560;
dies=474;
temps=[0:1/1440:N/1440-1/1440];


%Plot flow and chlorine
%Canet
figure(2)
subplot(2,1,1)
plot(temps,Cl(:,3),'b')
title('Chlorine Concentration output Tank 2')
xlabel('time [days]')
ylabel('ppm')
subplot(2,1,2)
plot(temps,Q(:,3),'r')
title('Flow input Tank 2')
xlabel('time [days]')
ylabel('l/s')


mostres0=zeros(size(Clor_Tank_2,1),1);
i=0;
for j=1:size(Clor_Tank_2,1)
    
    while mostres0(j)==0
        i=i+1;
        if DATA(i,1)==Clor_Tank_2(j,1) & DATA(i,2)==Clor_Tank_2(j,2) DATA(i,3)==Clor_Tank_2(j,3)
            mostres0(j)=i;
        end
    end
end
%%
%Calculate the added chlorine and its flow for each moth
i=1;
j=0;
k=0;
while i+j<53 
    k=k+1;
    i=i+j;
    j=0;
    mes0=Clor_Tank_2(i+1,2)
    mes=Clor_Tank_2(i+1,2);

    while mes==mes0  & i+j<54 
        j=j+1;
        mes=Clor_Tank_2(i+j,2);
    end
    if i+j==54
        j=j+1;
    end
    Cl_afegit(k,1)=Clor_Tank_2(i,4)-Clor_Tank_2(i+j-1,4);
    Cl_afegit(k,2)=mes0;
    Cl_afegit(k,3)=Clor_Tank_2(i+j-1,3);
    Cl_afegit(k,4)=mostres0(i);
    Cl_afegit(k,5)=mostres0(i+j-1);
    Cl_afegit(k,6)=143*Cl_afegit(k,1)/...
        ((sum(Q(Cl_afegit(k,4):Cl_afegit(k,5),4))+...
        sum(Q(Cl_afegit(k,4):Cl_afegit(k,5),5))+...
        sum(Q(Cl_afegit(k,4):Cl_afegit(k,5),6)))/60);
    j=j-1;
 
end

%plot the mean chlorine flow for each month
figure(4)
plot(Cl_afegit(:,2),Cl_afegit(:,6),'*');
xlabel('month')
ylabel('Mean chlorine flow [g/h]')
%%
%Weekly K_b estimation
%First the chlorine added is calculated
N_setmanes=floor((N-mostres0(1))/(24*7*60));
%Index vector for weeks

for i=1:N_setmanes
   index_setmanal(i,1)=mostres0(1)+(i-1)*(24*7*60);
   index_setmanal(i,2)=mostres0(1)+(i)*(24*7*60);
   j=0;
   k=1;
   while j==0
       if index_setmanal(i,1)>=Cl_afegit(k,4) & index_setmanal(i,1)<Cl_afegit(k,5);
           index_setmanal(i,3)=k;
           j=1;
       end
       k=k+1;
   end
   
       index_setmanal(i,3)=k-1;
end

%Estimation of weekly K_b
Cl0=(Cl(:,1)+Cl(:,2))/2;
for i=1:N_setmanes
    %mean flow of pump 1 in m3/h
    Q2_mean(i)=mean(Q(index_setmanal(i,1):index_setmanal(i,2),2));
    Cl_mean(i)=mean(Cl(index_setmanal(i,1):index_setmanal(i,2),4));
    %mean vloumens
    V1_mean(i)=mean(1000*H(index_setmanal(i,1):index_setmanal(i,2),1)/100)+6859*0.1^2*pi;
    V2_mean(i)=mean(700*H(index_setmanal(i,1):index_setmanal(i,2),3)/100);
    %Mean residence time in s
    TR1(i)=(V1_mean(i)/Q2_mean(i))*3600;
    %mean flows input and three outputs of the tank
    Q3_mean(i)=mean(Q(index_setmanal(i,1):index_setmanal(i,2),3));
    Q4_mean(i)=mean(Q(index_setmanal(i,1):index_setmanal(i,2),4));
    Q456_mean(i)=mean(Q(index_setmanal(i,1):index_setmanal(i,2),4))+...
        mean(Q(index_setmanal(i,1):index_setmanal(i,2),5))+...
        mean(Q(index_setmanal(i,1):index_setmanal(i,2),6));
    %mean residence time in s
    TR2(i)=(V2_mean(i)/Q3_mean(i))*3600;
    %mean chlorine concentration at the nput and aoutput in ppm
    Cl0_mean(i)=mean(Cl0(index_setmanal(i,1):index_setmanal(i,2),1));
    %estimate the weekly K_b
    syms k
    
    K(i)=vpasolve(0.6-Cl0_mean(i)*exp(-k*(TR1(i)+TR2(i)))-(Cl_afegit(index_setmanal(i,3),6))*exp(-k*TR2(i))==0, k);
end

%
%present weekly K_b for all the year
figure(5)
subplot(2,1,1)
index=DATA(index_setmanal(:,1),2)<4
plot(find(index),K(index),'*b')
hold on
index=(DATA(index_setmanal(:,1),2)>3 & DATA(index_setmanal(:,1),2)<7)
plot(find(index),K(index),'or')
index=(DATA(index_setmanal(:,1),2)>6 & DATA(index_setmanal(:,1),2)<10)
plot(find(index),K(index),'*r')
index=(DATA(index_setmanal(:,1),2)>9)
plot(find(index),K(index),'ob')
legend('1st trim','2ond trim','3rd trim','4th trim')
axis([0 60 0 1.5e-5])
xlabel('february 2017-april 2018 [week]')
ylabel('K_b [1/s]')

subplot(2,1,2)
plot(DATA(index_setmanal(:,1),2),K,'*')

ids={'jan';'feb';'mar';'apr';'may';'jun';'jul';'aug';'sep';'oct';'nov';'dec'}
ides=ids(DATA(index_setmanal(:,1),2))
plot(DATA(index_setmanal(:,1),2),K,'*')
legend('weekly K_b')

set(gca,'XTick',1:numel(ids))
set(gca,'XTickLabel',ids)
axis([0 13 0 1.5e-5])
ylabel('K_b [1/s]')
xlabel('february 2017-april 2018 [month]')








